function stDir = new_dirstruct()
    % stDir = new_dirstruct()
    % Returns an empty Directional Impulse Response struct
    
    % Source orientation angles
    stDir.azim = [];  % shape:(IRCOUNT) in deg
    stDir.elev = [];  % shape:(IRCOUNT) in deg

    % Source orientation cartesian vertices
    stDir.vertices = [];  % shape:(IRCOUNT, 3)
    
    % Convex Hull data
    stDir.convex_hull = [];   % shape:(<nchull>, 3)
    stDir.centroids = [];  % centroids of triangles in convex hull
    stDir.centroids_azim = [];  % azimuth of centroids in deg
    stDir.centroids_elev = [];  % elevation of centroids in deg
    stDir.geoeps = 1e-5;  % geometrical epsilon for 
                          % discrimination of determinant cases
    
    % Impulse Responses
    stDir.IR = [];  % (IRCOUNT, IRLEN)
    stDir.IRdelay = [];  % (IRCOUNT)
    stDir.fs = [];  % (1) or (IRCOUNT)
end
