MAKE_PLOTS = true;
NUMSAMPLES = 100;
NUMTESTS = 10;
GEOEPS = 1e-5;
phi = rand(NUMSAMPLES, 1) .* 360;
theta = rand(NUMSAMPLES, 1) .* 180 - 90;


[x, y, z] = sph2cart(phi/180*pi, theta/180*pi, 1);
dtri = delaunayTriangulation(x, y, z);
vertices = [x, y, z];
hull = convexHull(dtri);


for ii = 1:NUMTESTS
    dir = vertices(ii, :);
    [idx, t, u, v] = find_triangle_on_hull(dir, vertices, hull, GEOEPS);
    idx_tri = hull(idx, :);
    disp(ii)
    assert(any(ii==idx_tri), "Wrong triangle found.")
end
