% extremly simple test for interpolation of irs
% there can be critical cases not being covered at all.

interpolation_methods = { ...
    'blend', ...
    'delay_blend', ... 
    'magnitude_phase', ... 
    'magnitude_minimumphase'};
weights = [1/3, 1/6, 1/9];
dirs = new_dirstruct();
dirs.IR = zeros(3, 4);
dirs.IR(:, 1) = [1; 2; 3];
dirs.IRdelay = [1; 2; 3];
dirs.fs = 44100;
expected_ir_by_method = {
    [1, 0, 0, 0], ...
    [0, 1, 0, 0], ...
    [1, 0, 0, 0], ...
    [1, 0, 0, 0], ...
};
for kk = 1:length(interpolation_methods)
    method = interpolation_methods{kk};
    expected_ir = expected_ir_by_method{kk};
    ir = interpolate_directional_irs(dirs, weights, method);
    assert(all(abs(ir-expected_ir) < 1e-10), 'test failed.')
    disp('ok')
end


