function test_intersect_ray_triangle()
raydirs = [...
    [1, 1, 1];
    [1, 0, 0];
    [0, 1, 0];
    [0, 0, 1];
    [0, 1, 1];
    [1, 0, 1];
    [1, 1, 0]];
expected_weights = [...
    [1/3, 1/3, 1/3];
    [1, 0, 0];
    [0, 1, 0];
    [0, 0, 1];
    [0, 0.5, 0.5];
    [0.5, 0, 0.5];
    [0.5, 0.5, 0]];
edge1 = [1, 0, 0];
edge2 = [0, 1, 0];
edge3 = [0, 0, 1];
geoeps = 1e-5;
for kk = 1:length(raydirs)
    raydir = raydirs(kk, :);
    [intersected, t, u, v] = intersect_ray_triangle(...
        raydir, edge1, edge2, edge3, geoeps);
    weights = [1-u-v, u, v];
    
    assert(intersected == true, "All tested rays should intersect")
    assert(allnearto(weights, expected_weights(kk, :), 1e-10), "Unexpected weights found")
    disp('ok')
end

edge1 = [0, 0, 1];
edge2 = [0, 1, 0];
edge3 = [1, 0, 0];
for kk = 1:length(raydirs)
    raydir = raydirs(kk, :);
    [intersected, t, u, v] = intersect_ray_triangle(...
        raydir, edge1, edge2, edge3, geoeps);
    weights = [1-u-v, u, v];
    
    assert(intersected == true, "All tested rays should intersect")
    assert(allnearto(weights, expected_weights(kk, end:-1:1), 1e-10), "Unexpected weights found")
    disp('ok')
end
    function res = allnearto(a, b, tol)
        res = all(abs(a-b) < tol);
    end
end



