function test_pick_directional_ir()
    fs = 44100;
    ircount = 6;
    irlen = 2;
    phi = [0, 90, 180, 270, 0, 0];
    theta = [0, 0, 0, 0, 90, -90];
    
    function stDir = create_dirstruct_beam(beamidx, phi, theta)
        stDir = new_dirstruct();
        stDir.azim = phi;
        stDir.elev = theta;
        stDir.fs = fs;
        stDir.IR = zeros(ircount, irlen); 
        stDir.IR(beamidx, 1) = 1.0;
        stDir = create_convex_hull(stDir);
    end
    
    stDir = create_dirstruct_beam(1, phi, theta);
    
    ir = pick_directional_ir(0, 0, stDir, 'nearest');
    expected_ir = stDir.IR(1, :);
    assert(all(abs(ir-expected_ir)<1e-10))
    disp('ok')
    ir = pick_directional_ir(0, 0, stDir, 'magnitude_phase');
    expected_ir = [1, 0];
    assert(all(abs(ir-expected_ir)<1e-10))
    disp('ok')
    
    [az, el, r] = cart2sph(1, 1, 1);
    ir = pick_directional_ir(az*180/pi,el*180/pi,stDir,'magnitude_phase');
    expected_ir = [1/3, 0];
    assert(all(abs(ir-expected_ir)<1e-10))
    disp('ok')
    
    ir = pick_directional_ir(180, 0, stDir, 'magnitude_phase');
    expected_ir = [0, 0];
    assert(all(abs(ir-expected_ir)<1e-10))
    disp('ok')

end
