function weights = get_vertices_weights(vertices)
% Returns normalized distances of given vertices for first neares neighbors

% get first nearest neighbors in vertices
idx = knnsearch(vertices, vertices, 'K', 2);
% calculate euclidean distance
dvertnn = vertices(idx(:, 1), :) - vertices(idx(:, 2), :);
distance = sqrt(sum(dvertnn.^2, 2));  % euclidean ||q-p||_2
% normalize distance and return as weights
weights = distance/max(abs(distance));
end
