function hp = plot_dirstruct(stDir)
% very simple visualization of a dirstruct (source directivity impulse response
% data)
[b,a] = butter(4, [4000/stDir.fs, 8000/stDir.fs], 'bandpass');
weights = 10*log10(mean(abs(filter(b,a, stDir.IR,[],2)).^2, 2));
weights = weights+min(weights);
weights = weights/max(weights);
hp = patch('Vertices', stDir.vertices.*weights, 'Faces', stDir.convex_hull);
set(hp,'FaceColor', 'none', 'EdgeColor', 'black', 'EdgeAlpha', 0.1);
daspect([1 1 1])
view(3);
camlight
lighting gouraud
xlabel('x')
ylabel('y')
zlabel('z')
view(65,-20)
end
