% ATTENTION: this is a human validation test script without assertions!
% see ../directional_ir/test_*.m for lower level tests.

% souece options
op.dir_db = 'sofa';  % expects a cfg.dir_path__sofa in the config struct defined by userconfig this is idiosyncratic to razr     
                     % but you can name it different as well.
                     % this whole architecture of dir_db and dir_path__<dir_db> loading should be overthought (apply_source_dir)

% Create directional ir struct with a beam in only one direction.
fs = 44100;
ircount = 6;
irlen = 2;
phi = [0, 90, 180, 270, 0, 0];
theta = [0, 0, 0, 0, 90, -90];
beamidx = 4;                     
stDir = new_dirstruct();
stDir.azim = phi;
stDir.elev = theta;
stDir.fs = fs;
stDir.IR = zeros(ircount, irlen); 
stDir.IR(beamidx, 1) = 1.0;
stDir = create_convex_hull(stDir);
op.dir_struct = stDir;
op.dir_interpolation_method = 'magnitude_phase';

op.ism_enableSourceDir = 1;

% receiver options
op.spat_mode = 'shm';

% load a pre defined room
room = get_room_L_Dir;

% Setup of source and receiver
room.recpos = [2.00, 2.06, 1.50]; 
room.srcpos = [1.00, 2.06, 1.50];
room.srcdir	= [0,0];
room.recdir = [180,0];
scene(room)
% generate ir front room L
ir_front = razr(room, op);

% generate ir back room L
room.srcdir = [180, 0];
scene(room)
ir_back = razr(room, op);

room.srcdir = [90, 0];
scene(room)
ir_side = razr(room, op);

figure()
subplot(3,1,1)
plot(ir_front.sig)
title('front')

subplot(3,1,2)
plot(ir_back.sig)
title('back')

subplot(3,1,3)
plot(ir_side.sig)
title('side')

% apply rirs
% front = apply_rir(ir_front);
% back = apply_rir(ir_back);
% side = apply_rir(ir_side);

%% listen to samples
%soundsc(front_L{1}, ir_front_L.fs)
%soundsc(back_L{1}, ir_back_L.fs)
