function op = rotate_array(room, op)
% Rotate array to account for receiver orientation

%------------------------------------------------------------------------------
% RAZR engine for Mathwork's MATLAB
%
% Version 0.96.3
%
% Author(s): Josef Poppitz
%
% Copyright (c) 2014-2023, Torben Wendt, Steven van de Par, Stephan Ewert,
% University of Oldenburg, Germany.
%
% This work is licensed under the
% Creative Commons Attribution-NonCommercial-NoDerivs 4.0 International
% License (CC BY-NC-ND 4.0).
% To view a copy of this license, visit
% http://creativecommons.org/licenses/by-nc-nd/4.0/ or send a letter to
% Creative Commons, 444 Castro Street, Suite 900, Mountain View, California,
% 94041, USA.
%------------------------------------------------------------------------------


if isempty(op.array_pos)
    return;
end

% SE 11.10.2022 remove old code

% [az, el, r] = cart2sph(op.array_pos(:, 1), op.array_pos(:, 2), op.array_pos(:, 3));
% azim = rd2dg(az);
% elev = rd2dg(el);
% 
% azim2 = azim + room.recdir(1);
% azim2(azim2 > 180) = azim2(azim2 > 180) - 360;
% 
% elev2 = elev + room.recdir(2);
% elev2(elev2 > 180) = elev2(elev2 > 180) - 360;
% 
% az2 = dg2rd(azim2);
% el2 = dg2rd(elev2);
% 
% %[op.array_pos(:, 1), op.array_pos(:, 2), op.array_pos(:, 3)] = sph2cart(az2, el2, r);
% [op.array_pos2(:, 1), op.array_pos2(:, 2), op.array_pos2(:, 3)] = sph2cart(az2, el2, r); % just for debugging

% SE 11.10.2022 new code using rotation matrix

% get axis/rotm 
% FIXME this should be done once and axis/rotm should be
% written to room structure
% Angles2Axis is the same as MATLABs robotics toolbox eul2rotm(angles/180*pi)
rotm = Angles2AxisSubf( [room.recdir(1) -room.recdir(2) 0] ); % invert elev to pitch, ignore roll if erratically specified in this notation

vecOut = rotm*op.array_pos';
op.array_pos=vecOut';

% check deviation for azim rotation in old code. basically 0
%   max(max(abs(op.array_pos-op.array_pos2)))


end

% SE FIXME make seoarate function
function axis = Angles2AxisSubf( angles )

% axis is a right-handed cart coord system
% first column x (fwd), second column y (left), third column z (up)

% angles are yaw, pitch, roll

% this also constructs a rotation matrix, do we have it already in RAZR?

% should we use degree or rad? MATLAB convention is rad

% this performs euler angle rotation first around x (roll), then pitch,
% then yaw
% Matrix equals rotation matrix R_z(yaw)_y(pitch)_x(roll)

% SE qauke order, I like yaw (z), pitch(y), roll(x) more
% #define PITCH		0
% #define YAW			1
% #define ROLL		2

% same as MATLABs robotics toolbox eul2rotm(angles/180*pi)

    YAW = 1;   % counterclockwise around z (equals azimuth)
    PITCH = 2; % counterclockwise around y (positive is nose down, opposite to elevation)
    ROLL = 3; % counterclockwise around x (forward axis) 
    
    M_PI = pi;
    
    angle = angles(YAW) * (M_PI*2 / 360);
    sy = sin(angle);
    cy = cos(angle);
    angle = angles(PITCH) * (M_PI*2 / 360);
    sp = sin(angle);
    cp = cos(angle);
    angle = angles(ROLL) * (M_PI*2 / 360);
    sr = sin(angle);
    cr = cos(angle);
    
    forward(1) = cp*cy;
    forward(2) = cp*sy;
    forward(3) = -sp;
    
    left(1) = sr*sp*cy+cr*-sy;
    left(2) = sr*sp*sy+cr*cy;
    left(3) = sr*cp;
    
    up(1) = cr*sp*cy+-sr*-sy;
    up(2) = cr*sp*sy+-sr*cy;
    up(3) = cr*cp;
    
    %axis = [forward; left; up];
    axis = [forward' left' up']; % changed to columns
end
