% approx -3dB/oct LP, SE 11/2021

function [b,a] = halfOrderLPapprox(fcut,fs)

% % target was
% fOrder = 0.5;
% blendExpn = 1.3;
% target = 10*log10(1./(abs(fvec/ftarget).^(2*fOrder/blendExpn) + 1).^blendExpn);

globalGain = 1;

designType = 0; % 1 is 6 coeffs, 0 is 5 coeffs == 2 SOS

if designType == 1
    % restrict design range
    if fcut < 5
        % -10 dB per decade
        globalGain = sqrt(fcut/5);
        fcut = 5; % stick to 10 Hz, ignore errors we make below 10 Hz
    end
    
    % approx -3 dB/oct filter
    f3 = fcut/4;  %fcut cannot go below 1 Hz @ fs 44100, gets unstable
    [b,a] = highShelvingMatched(f3,-3,fs);
    
    [b2,a2] = highShelvingMatched(f3*10,-6,fs);
    b = conv(b, b2);
    a = conv(a, a2);
    
    [b2,a2] = highShelvingMatched(f3*80,-9,fs);
    b = conv(b, b2);
    a = conv(a, a2);
    
    [b2,a2] = highShelvingMatched(f3*1000,-12,fs);
    b = conv(b, b2);
    a = conv(a, a2);
    
    % IRIfolp(f0,fs), finish with a LP
    a2 = exp(-(2*pi*f3*6000)/fs);
    b2 = 1 - a2;
    a2 = [1, -a2];
    b = conv(b, b2);
    a = conv(a, a2);
    
    b = b*globalGain;
else
    atten1 = -3;
    atten2 = -6;
    % restrict design range
    if fcut < 100
        % from here we use global gain and extent gain of the lower
        % shelving filters
        % -10 dB per decade
       
        atten1mod = -6 * (1-fcut/100)^2;  % FIXME can be improved with -7 * () but then the weight function has to be changed
        atten2mod = -3 * (1-fcut/100)^2; % FIXME can be improved with -4 * () but then the weight function has to be changed
        
        globalGain = sqrt(fcut/100) * 10^((-atten1mod-atten2mod)/20);
        atten1 = atten1 + atten1mod;
        atten2 = atten2 + atten2mod;

        fcut = 100; % stick to 10 Hz, ignore errors we make below 10 Hz
    end
    
    % approx -3 dB/oct filter
    f3 = fcut/4;  %fcut cannot go below 1 Hz @ fs 44100, gets unstable
    [b,a] = highShelvingMatched(f3,atten1,fs);
    
    [b2,a2] = highShelvingMatched(f3*10,atten2,fs);
    b = conv(b, b2);
    a = conv(a, a2);
    
    [b2,a2] = highShelvingMatched(f3*80,-9,fs);
    b = conv(b, b2);
    a = conv(a, a2);
    
    [b2,a2] = highShelvingMatched(f3*1000,-12,fs);
    b = conv(b, b2);
    a = conv(a, a2);
    
    b = b*globalGain;
end


