clear;
close all;


% source options
op.dir_mode = 'sofa';  % expects a cfg.dir_path__sofa in the config struct defined by userconfig this is idiosyncratic to razr
                     % but you can name it different as well.
                     
% You may alternatively specify a full path to the SOFA src dir database here
% e.g.
op.dir_database = 'C:\razr\myDIR\myDIR.sofa';

% In the SOFA directivity file, the the directional data has to be saved as single channel 'GeneralFIR' of the SOFA convention.
% Receiver units are expected to be
%
% ReceiverPosition_Type = 'spherical';
% ReceiverPosition_Units = 'degree, degree, metre';
% 
% And source position value is expected to be 
%
% SourcePosition = [0, 0, 0].

                  
%   Interpolation method options:
%   'nearest': returns nearest DIR to given angles.
%   'blend' : returns an interpolated DIR from the 
%       three DIRs located on a triangle around given angles.
%   'delay_blend': weighted average with delays from stDir.IRdelays, 
%   'magnitude_phase': weighted average of magnitude and phase.
%   'magnitude_minimumphase': averages magnitude spectra
%      and creates response using minimum phase.  
op.dir_interpolation_method = 'nearest';
op.ism_enableSourceDir = 1;

% receiver options
op.spat_mode = 'shm';

% load a pre defined room
room = get_room_L_Dir;

% Setup of source and receiver
room.srcpos = [2.00, 2.06, 1.50]; 
room.recpos = [1.00, 2.06, 1.50];
room.recdir	= [0,0];
room.srcdir = [180,0];
scene(room)
% generate ir front room L
ir_front_L = razr(room, op);

% generate ir back room L
room.srcdir = [0, 0];
scene(room)
ir_back_L = razr(room, op);

% apply rirs
front_L = apply_rir(ir_front_L);
back_L = apply_rir(ir_back_L);

%% listen to samples
%soundsc(front_L{1}, ir_front_L.fs)
%soundsc(back_L{1}, ir_back_L.fs)
